
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cctype>

using std::map;
using std::vector;
using std::string;

int get_name_index(const char *name)
{
	unsigned ii, len=strlen(name);
	unsigned ret = 0;
	for (ii=0; ii<len; ii++) {
		if (name[ii]=='.') {
			ret++;
		}
		else if (!isblank(name[ii])) break;
	}
	if (ret) return ret;

	for (ii=len-1; ii>=0; ii--) {
		if (name[ii]=='.')
			ret--;
		else if (!isblank(name[ii])) break;
	}
	return ret;
}

const string get_name(const char *name)
{
	unsigned ii, jj, len=strlen(name);
	for (ii=0; ii<len; ii++) {
		if (!(name[ii]=='.' || isblank(name[ii]))) break;
	}

	for (jj=ii; jj<len; jj++) {
		if (name[jj]=='.' || isblank(name[jj])) break;
	}

	return string(name+ii, jj-ii);
}

const string compute_name(const vector<string>& names)
{
	map<int, string> indexes;
	vector<string>::const_iterator it;
	for (it=names.begin(); it!=names.end(); it++) {
		int ind = get_name_index((*it).c_str());
		if (indexes.find(ind)!=indexes.end()) {
			std::cerr << "bad" << std::endl;	
		}
		if (strlen((*it).c_str())) indexes[ind] = get_name((*it).c_str());
	}

	string ret;
	map<int, string>::iterator mit;
	for (mit=indexes.begin(); mit!=indexes.end(); mit++) {
		ret += (*mit).second;
	}
	return ret;
}

#if 0
int main()
{
	vector<const char *> names;
	names.push_back("..suffix2");
	names.push_back(".suffix1");
	names.push_back("prefix1.");
	names.push_back("name");

	string s = compute_name(names);

	std::cerr << s << std::endl;
	return 0;
}
#endif
