
#ifndef _HUFFMAN_H_
#define _HUFFMAN_H_

#include <list>
#include <vector>
#include <functional>

typedef struct node_t {

	double prob;
	double height;
	node_t *left_child;	
	node_t *right_child;

} HuffmanTreeNode;

typedef class huffman_tree {


	public:
		huffman_tree(const std::vector<double>& probs);
		~huffman_tree();

		double getHeight() {return (root)?root->height:0.0;}

	private:
		std::vector<HuffmanTreeNode> *nodePool;
		int nodePtr;

		/* functor for sorting */
		class nodePtrCompare: public std::less <HuffmanTreeNode *> {
			public:
				bool operator()(HuffmanTreeNode *lhs, HuffmanTreeNode *rhs) {
					return lhs->prob < rhs->prob;
				}
		};

		std::list<HuffmanTreeNode *> nodeList;
		HuffmanTreeNode *root;

		HuffmanTreeNode *buildTree();

} HuffmanTree;

#endif
