
#ifndef __LIB_OSM_H__
#define __LIB_OSM_H__

/* user of this file must provide macro
 * MACH_ID_T and OPER_ID_T
 */
#ifndef MACH_ID_T
#error "MACH_ID_T undefined!"
#else
#ifndef OPER_ID_T
#error "OPER_ID_T undefined!"
#else
#ifndef SIMULATOR
#error "SIMULATOR undefined!"
#else


#include "lib_types.hpp"
#include "managers.hpp"
#include "osm.hpp"

#define FUNC_NAME(_a) _a
#define FUNC_REF(fname, args...) fname(args)
#define EFUNC_REF(fname, args...) fname(args)
#define DIRTY_FUNC_REF(fname, args...) fname(args)
#define DIRTY_EFUNC_REF(fname, args...) fname(_machine->get_simulator(), args)
#define DIRTY_EFUNC_DEC(fname, args...) extern void fname(SIMULATOR *, args)
#define EFUNC_DEC(fname, args...) extern void fname(args)

#define VAR_REF(_a) _a
#define ARG_REF(_a) _a
#define BDG_REF(_a) (*_a)
#define DEF_REF(_a) _a
#define MVR_REF(_v) _machine->_v
#define BUF_REF(_v) _machine->_v

#define BASE_MACHINE _base_machine
#define BASE_OPERATION _base_operation
#define OPER_CLASS(_a) _ ## _a

#define MACH_CLASS(_a) _a

#define MANG_CLASS(_a) _a

#define TEST_RELEASE(_a) BUF_REF(_a)->test_release(_machine)

#define RELEASE(_a) BUF_REF(_a)->release(_machine), BUF_REF(_a)=NULL

#define TEST_ALLOCATE(_a) \
		_machine->get_simulator()->_a->token_free_for_alloc(_machine)
#define TEST_ALLOCATE_ID(_a,_b) \
		_machine->get_simulator()->_a->token_free_for_alloc(_b,_machine)

#define ALLOCATE(_a) \
		_machine->get_simulator()->_a->allocate_token(_machine)
#define ALLOCATE_ID(_a,_b) \
		_machine->get_simulator()->_a->allocate_token(_b,_machine)

#define DISCARD(_a) BUF_REF(_a)->discard(_machine), BUF_REF(_a)=NULL

#define TEST_INQUIRE(_a) \
		_machine->get_simulator()->_a->token_free_for_inquire(_machine)
#define TEST_INQUIRE_ID(_a,_b) \
		_machine->get_simulator()->_a->token_free_for_inquire(_b,_machine)

#define READ_TOKEN(_a,_b) \
		_a = _machine->get_simulator()->_b->read_token(_machine)
#define READ_TOKEN_ID(_a,_b,_c) \
		_a = _machine->get_simulator()->_b->read_token(_c,_machine)

#define READ(_a, _b) _a = BUF_REF(_b)->read(_machine)

#define WRITE_TOKEN(_a,_b) \
		_machine->get_simulator()->_a->write_token(_b,_machine)
#define WRITE_TOKEN_ID(_a,_b,_c) \
		_machine->get_simulator()->_a->write_token(_b,_c,_machine)

#define WRITE(_a,_b) BUF_REF(_a)->write(_b,_machine)

#define RUN_EDGE_EVAL(_id) _machine->get_edge(_id)->eval()

#define STRING_EVAL(_a) 

#define GET_OPERATION(_a) _machine->get_simulator()->allocate_operation(_a);
#define DECODE(_a,_b) decode_ ## _a(VAL_OF(_b))

#define COMPARE(a,b,c) (a b c).val()

#define RETIRE_BUFFER(a) //assert(a==NULL)
#define FLUSH_BUFFER(a)  if (a!=NULL) {\
		a->discard(this); \
		a = NULL; \
	}

#endif
#endif
#endif
#endif
