
#include <cstdio>
#include <csignal>
#include <cstdlib>
#include "simulator.hpp"

static void usage(char *fname)
{
	char *cp;
	if ((cp = rindex(fname, '/'))!=NULL) cp++;
	else cp = fname;
	fprintf(stderr, 
		"usage : %s [-h] <file name>\n"
		"  -h : print this message\n"
		"  file name : the ARM ELF32 program to simulate\n", cp);
}


int main(int argc, char *argv[], char *envp[])
{
	int i;
	char *prog_name = NULL;
	char *fpe_name = NULL;
	bool verbose = true;
	uint64_t max_cnum = (uint64_t)-1;
	void (*prev_sigint_handler)(int);

	for(i = 1; i < argc; i++)
	{
		if(strcmp(argv[i], "-h") == 0) {usage(argv[0]); return 0;} else
		if(!prog_name)
		{
			prog_name = argv[i];
			break;
		}	
	}

	/* emulator instance */
	if(prog_name)
	{
		arm_simulator *disarm = new arm_simulator(verbose);

		disarm->disarm_program(prog_name);

		disarm->dump_stats(stderr);
	}
	else usage(argv[0]);

	return 0;
}

