
#include "emumem.h"

#include <cstring>
#include <iostream>

using namespace emulator;

memory::memory()
{
	data = new byte_t[C54X_MEMORY_SIZE];
	reset();
}

memory::~memory()
{
	delete [] data;
}

void memory::reset()
{
	memset(data, 0, C54X_MEMORY_SIZE);
}

void memory::read_block(void *buf, target_addr_t addr, unsigned int size)
{
	memcpy(buf, data + addr, size);
}

void memory::write_block(target_addr_t addr, void *buf, unsigned int size)
{
	memcpy(data + addr, buf, size);
}

void memory::set_block(target_addr_t addr, byte_t value, unsigned int size)
{
	memset(data + addr, value, size);
}

