
#include "more_managers.hpp"
#include "simulator.hpp"

#include <iostream>

void fetch_manager::update_on_clock()
{
	/* a new OSM comes in */
	if (mRS->branch_taken()) {
		pc = (mRS->get_target());
	}
	else if (trigger) {
		pc += 1;		// increment pc
	}
	trigger = false;
}

void mem_ctrl::update_on_clock() 
{
	if (trigger) {
		assert(size==16);
		addr = mMemAddr->get_value().val();
		if (isRead) {
			mMemData->set_value(mem->read_word(addr<<1));
#undef _DEBUG_MEM
#ifdef _DEBUG_MEM
			std::cerr << "read at " << std::hex << addr << ": "
				   << mMemData->get_value().hex() << std::endl;
#endif
		}
		else {
			mem->write_word(addr<<1,(uint16_t)mMemData->get_value().val());
#ifdef _DEBUG_MEM
			std::cerr << "write at " << std::hex << addr << ": "
				   << mMemData->get_value().hex() << std::endl;
#endif
		}
		trigger = false;
	}
}
