
#include "ns_interface.hpp"
#include "ns_manager.hpp"
#include "ns_routing.hpp"
#include "ns_data_type.hpp"
#define BUS_TYPE_LIMIT 4
unsigned bus_utilize_counter_r;
unsigned bus_utilize_counter_w;
unsigned bus_utilize_counter_a;
unsigned glb_packet_count[NETWORK_SIZE][NETWORK_SIZE];
unsigned glb_total_packet_count;
double glb_latency_count[NETWORK_SIZE][NETWORK_SIZE];
double glb_bus_latency_count[NETWORK_SIZE][NETWORK_SIZE][BUS_TYPE_LIMIT];
int glb_bus_packet_count[NETWORK_SIZE][NETWORK_SIZE][BUS_TYPE_LIMIT];
int previous_origin_time[NETWORK_SIZE][NETWORK_SIZE][VC_SIZE];
int packet_counter[NETWORK_SIZE][NETWORK_SIZE][VC_SIZE];
int pac_id;
int count=0;
int abort_count = 0;
int lock_count = 0;
int rearb_count = 0;

_UINT_T(64) glb_t;
_UINT_T(8) glb_s;
_UINT_T(8) glb_ty;
_UINT_T(8) glb_a;
_UINT_T(8) glb_i;
_UINT_T(8) glb_ni;
_UINT_T(8) glb_v;
_UINT_T(8) glb_abort;

void stat_init(){

  for (int i=0;i<NETWORK_SIZE;i++){
     for (int j=0;j<NETWORK_SIZE;j++){
    glb_packet_count[i][j] = 0;
    glb_latency_count[i][j] = 0.0; 
     for (int k=0;k<VC_SIZE;k++){ 
        previous_origin_time[i][j][k] =0;
        packet_counter[i][j][k] = 0;
    }
     for (int k=0;k<BUS_TYPE_LIMIT;k++){ 
        glb_bus_latency_count[i][j][k] = 0;
        glb_bus_packet_count[i][j][k] = 0;
    }        
  }
 }
 glb_total_packet_count = 0;
 bus_utilize_counter_r = 0;
 bus_utilize_counter_w = 0;
 bus_utilize_counter_a = 0;
 
 pac_id = 0;
}

#if 0

void calc_next_src_tlb(){
  
  /* get torus size */
        unsigned torus_size = TORUS_SIZE;
        unsigned z = torus_size/2;
        unsigned size= torus_size;
        unsigned src_x, src_y, dest_x, dest_y;

  for(int src_v = 0; src_v< NETWORK_SIZE; src_v++){
    for(int dest_v = 0; dest_v< NETWORK_SIZE; dest_v++){
       /* go Y-axis first */
        src_x = src_v/torus_size; 
        src_y = src_v%torus_size;
        dest_x = dest_v/torus_size;
        dest_y = dest_v%torus_size;
    /* go minimum routing */
    if ((src_y < dest_y) && ((dest_y - src_y) <= z) || ((src_y > dest_y) && ((src_y - dest_y) > z))) {
      glb_next_interface[src_v][dest_v] = NORTH;
      glb_next_other_interface[src_v][dest_v] = SOUTH;
      src_y ++;
      if (src_y == size) src_y = 0;
      
    }else if ((src_y < dest_y) && ((dest_y - src_y) > z) || ((src_y > dest_y) && ((src_y - dest_y) <= z)))    {
      glb_next_interface[src_v][dest_v]= SOUTH;
      glb_next_other_interface[src_v][dest_v] = NORTH;
      src_y --;
      if (src_y == -1) src_y = size-1;
       
    }else if (src_y == dest_y){

      /* then go X-axis */
      if ((src_x < dest_x) && ((dest_x - src_x) <= z) || ((src_x > dest_x) && ((src_x - dest_x) > z))){
        glb_next_interface[src_v][dest_v] = EAST;
        glb_next_other_interface[src_v][dest_v] = WEST;
        src_x ++;
        if (src_x == size) src_x = 0; 
      }else if ((src_x < dest_x) && ((dest_x - src_x) > z) || ((src_x > dest_x) && ((src_x - dest_x) <= z))) {
        glb_next_interface[src_v][dest_v] = WEST;
        glb_next_other_interface[src_v][dest_v] = EAST;
        src_x --;
        if (src_x == -1) src_x = size-1; 
      }else if ((src_x == dest_x)){
        glb_next_interface[src_v][dest_v] = EXIT;
        glb_next_other_interface[src_v][dest_v] = EXIT;
       }
    }

     glb_next_addr[src_v][dest_v]= (src_x*torus_size) + src_y;
   }
  }

}

#endif

void set(_simulator *sim,const _NS_DATA_TYPE& data_val,const _UINT_T(8)& ty_val,const _UINT_T(64)& t_val, const _UINT_T(8)& s_val, const _UINT_T(8)& a_val, const _UINT_T(8)& i_val,
		const _UINT_T(8)& ni_val,const _UINT_T(8)& v_val )
{
        glb_t = t_val;
        glb_s = s_val,
        glb_ty = ty_val,
	glb_a = a_val;
	glb_i = i_val;
	glb_ni = ni_val;
        glb_v = v_val;
        glb_data = data_val;
}

void get(_simulator *sim, _NS_DATA_TYPE& data_val, _UINT_T(8)& ty_val, _UINT_T(64)& t_val,_UINT_T(8)& s_val,_UINT_T(8)& a_val, _UINT_T(8)& i_val, _UINT_T(8)& ni_val,_UINT_T(8)& v_val )
{
        t_val = glb_t; 
        s_val = glb_s;
        ty_val = glb_ty;
	a_val = glb_a;
	i_val = glb_i;
	ni_val = glb_ni;
        v_val = glb_v;
        data_val = glb_data;
}

void adjust_burst_count_write(_simulator *sim, const _UINT_T(8)& s_val, const _UINT_T(8)& t_val, _UINT_T(8)& new_val ){
        if (s_val.val() ==0){
         new_val = t_val;
        }else{
         new_val = s_val;
        }
}

void set_abort(_simulator *sim, const _UINT_T(8)& s_val){
        glb_abort = s_val;
}

void get_abort(_simulator *sim, _UINT_T(8)& s_val){
        s_val = glb_abort;
}

void fetch_time(_simulator *sim,_UINT_T(64)& t_val){

   t_val = sim->get_cycle_count();
}

void gen_rand_vc(_simulator *sim,_UINT_T(8)& t_val){

   t_val = myrand()% VC_SIZE; 

     }

void set_zero(_simulator *sim,_UINT_T(8)& t_val){

   t_val = 0;

     }


void gen_pac_id(_simulator *sim,_UINT_T(32)& t_val){

   t_val = pac_id;
   pac_id ++; 

    }

void gen_rand_bus_trans_type(_simulator *sim,_UINT_T(8)& t_val){
   
   int t = myrand()% 100;
   if (t>90){
	    t_val = 2;  //split_transaction read
   }
   else if (t>50){
        t_val = 0;   // read
   }else{
        t_val = 1;   //write
 }
}


void gen_rand_bus_beat_num(_simulator *sim,_UINT_T(8)& t_val){
   
   int t = myrand()% 100;

   if (t>90){
        t_val = 4;
   }else if (t > 70){
        t_val = 2;
 }else{
	    t_val = 1;
 }
}

void gen_rand_split_delay(_simulator *sim,_UINT_T(8)& t_val){

  gen_rand_bus_beat_num(sim, t_val);
 
}
void gen_rand_type(_simulator *sim,_UINT_T(8)& t_val){

   /* using 80:20 ratio for 1 beat : 2 beat transactions */
   int t = myrand()% 100;
   if (0){
        t_val = 2;
   }else{
        t_val = 1;
 }
}

void gen_rand_bus_data(_simulator *sim,_UINT_T(DATA_WIDTH)& t_val,const _UINT_T(8)& x_val){

  int * z = (int *) malloc((size_t) x_val.val()*sizeof (int)); //@@@
  for (int i = 0; i < x_val.val(); i++){
    z[i] = i+33;
  }
  t_val = (unsigned int) z;
}

void recv_rand_bus_data(_simulator *sim,const _UINT_T(DATA_WIDTH)& t_val,const _UINT_T(8)& x_val ){
  
  int *z =( int *) t_val.val();
  #if 0
  for (int i = 0; i < x_val.val(); i++){
    fprintf(stderr, " recv: output = %d for beat %d\n",z[i], i); 
  }
  #endif
  free(z);
}

void debug_rearb(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "Rearbitrate read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{
   fprintf(stderr, "Rearbitrate write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}
void debug_rearb_spawn(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "Spawned Rearbitrate read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{
   fprintf(stderr, "Spawned Rearbitrate write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_primary(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "Primary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{
   fprintf(stderr, "Primary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_secondary(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val ){
  long cycle_count = (long)sim->get_cycle_count();
 if (r_val.val() == 0){
   fprintf(stderr, "Secondary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{ 
   fprintf(stderr, "Secondary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_secondary_dack(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val  ){
   long cycle_count = (long)sim->get_cycle_count();
 if (r_val.val() == 0){
   fprintf(stderr, "DACK Secondary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(),(long)cycle_count/3,(long)(cycle_count%3));
  }else{ 
   fprintf(stderr, "DACK Secondary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(),(long)cycle_count/3,(long)(cycle_count%3));
 }
}
void debug_end_primary(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val ){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "End Primary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else if (r_val.val() == 1){ 
   fprintf(stderr, "End Primary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }else if (r_val.val() == 3){ 
   fprintf(stderr, "End Primary burst read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_end_secondary(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val , const _UINT_T(8)& r_val){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "End Secondary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else if (r_val.val() == 1){ 
   fprintf(stderr, "End Secondary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }  else if (r_val.val() == 3){ 
   fprintf(stderr, "End Secondary  burst read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_begin_primary(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val , const _UINT_T(8)& r_val){
  long cycle_count = (long)sim->get_cycle_count();
 if (r_val.val() == 0){
   fprintf(stderr, "Begin Primary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(),(long)cycle_count/3,(long)(cycle_count%3) );
  }else if (r_val.val() == 1){ 
   fprintf(stderr, "Begin Primary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(),(long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_begin_secondary(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val ){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "Begin Secondary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{ 
   fprintf(stderr, "Begin Secondary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void print_one(_simulator *sim, const _UINT_T(8)& t_val){
 fprintf(stderr, "debug: value = %d\n", t_val.val());
}


void debug_secondary_abort(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val ){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "Abort Secondary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{ 
   fprintf(stderr, "Abort Secondary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void debug_primary_abort(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val, const _UINT_T(8)& r_val ){
   long cycle_count = (long)sim->get_cycle_count();
  if (r_val.val() == 0){
   fprintf(stderr, "Abort Primary read: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
  }else{ 
   fprintf(stderr, "Abort Primary write: %d, %d at time = (%ld.%ld)\n", t_val.val(), b_val.val(), (long)cycle_count/3,(long)(cycle_count%3));
 }
}

void gen_rearb_fix(_simulator *sim, const _UINT_T(8)& rearb_val, _UINT_T(8)& t_val, _UINT_T(8)& d_val, _UINT_T(8)& type_val, _UINT_T(8)& b_val){
 if (rearb_val.val() ==1){
        /* now only support rearb_delay == 1 */
                t_val = 1;
                d_val = 3;
                type_val = 1;
        /* write from 2 to 3 */
                b_val = 2;
                rearb_count = 1;
        fprintf(stderr, "Generate Rearbitration Values.\n");
  }else{
        t_val =0;
        rearb_count = 1;
 }
}

void gen_re_arb(_simulator *sim, _UINT_T(8)& t_val, _UINT_T(8)& d_val, _UINT_T(8)& type_val, _UINT_T(8)& b_val){
         
  if(BUS_CONFIG == 519){
       if(rearb_count == 0){
                t_val = 1;
                d_val = 0;
                type_val = 1;
                b_val = 4;
                rearb_count = 1;
       }
  }else if (BUS_CONFIG == 520){
       if(rearb_count == 0){
                t_val = 1;
                d_val = 0;
                type_val = 1;
                b_val = 4;
                rearb_count = 1;
       }
  }else{
        t_val =0;
        rearb_count = 1;
 }
}


void get_master_abort(_simulator *sim,_UINT_T(8)& t_val){
 if(BUS_CONFIG == 513){
   if (abort_count == 0 || abort_count == 1){
        t_val = 1;
   }else{
        // if not, leave it alone
        //t_val = 0;
  }
 }else{
   // if not, leave it alone 
   //t_val = 0;
 }
 abort_count ++;
}

/*
void get_master_lock(_simulator *sim,_UINT_T(8)& t_val){
 if(BUS_CONFIG == 518){
   if (lock_count == 0){
        t_val = 1;
   }else{
        t_val = 0;
  }
 }else{
   t_val = 0;
 }
 lock_count ++;
}

*/

void update_bus_counter(_simulator *sim, const _UINT_T(8)& t_val, const _UINT_T(8)& b_val ){

  #ifdef STAT
  if ( t_val.val() == 0){// read
    bus_utilize_counter_r += b_val.val();
   }else if (t_val.val() == 1){//write
    bus_utilize_counter_w += b_val.val();
  }else  if (t_val.val() == 3){//arbiter
    bus_utilize_counter_a += b_val.val();
  }

        

  #endif
}

void gen_rand_dest(_simulator *sim,const _UINT_T(8)& a_val,_UINT_T(8)& t_val){
   int src, dest;
   src = a_val.val();
   dest = rand()% NETWORK_SIZE;
   while( src == dest){
                    dest = rand()% NETWORK_SIZE;
    }
   t_val = dest;
}


void print_stat(){
  double total_latency = 0.0;
  
    fprintf(stderr, "Printing all the latencies for each node:\n");
    fprintf(stderr, ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");
    for (int i=0;i<NETWORK_SIZE;i++){
      for (int j=0;j<NETWORK_SIZE;j++){
        total_latency += glb_packet_count[i][j]*glb_latency_count[i][j];
        
       fprintf(stderr, "src = %u, dest = %u, count = %u",i, j, glb_packet_count[i][j]);   
       
       fprintf(stderr, " latency = %f\n", glb_latency_count[i][j]);      
                  
    }
   }

    fprintf(stderr, "Total number of packets = %u, latency = %f\n", glb_total_packet_count, (total_latency/glb_total_packet_count));
    fprintf(stderr, "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n");
    fprintf(stderr, "End printing all the latencies for each node:\n");         
}

void print_vc_pair(_simulator *sim, const _UINT_T(8)& a_val, const _UINT_T(8)& s_val, const _UINT_T(8)& d_val, const _UINT_T(8)& t_val, const _UINT_T(8)& ty_val ){
  fprintf(stderr, "current vc pair is (%d,%d,%d,%d,%d) at time=%ld\n", a_val.val(), s_val.val(), d_val.val(), t_val.val(), ty_val.val(),sim->get_cycle_count()); 
}

void print_next_vc_pair(_simulator *sim,const _UINT_T(8)& a_val,  const _UINT_T(8)& s_val, const _UINT_T(8)& d_val, const _UINT_T(8)& t_val, const _UINT_T(8)& ty_val ){
  fprintf(stderr, "next vc pair is (%d, %d,%d,%d,%d) at time=%ld\n", a_val.val(), s_val.val(), d_val.val(), t_val.val(), ty_val.val(),sim->get_cycle_count()); 
}
void print_start_vc(_simulator *sim, const _UINT_T(8)& a_val, const _UINT_T(8)& s_val, const _UINT_T(8)& d_val, const _UINT_T(8)& t_val, const _UINT_T(8)& ty_val ){
  fprintf(stderr, "fire next is (%d,%d,%d,%d,%d) at time=%ld\n", a_val.val(), s_val.val(), d_val.val(), t_val.val(), ty_val.val(),sim->get_cycle_count()); 
}


void print_buf_recv(_simulator *sim, const _UINT_T(8)& s_val, const _UINT_T(8)& od_val, const _UINT_T(8)& d_val, const _UINT_T(64)& t_val,const _UINT_T(8)& inf_val, const _UINT_T(8)& vc_val, const _UINT_T(8)& ft_val,const _UINT_T(DATA_WIDTH)& data_val ){


#ifdef STAT2 
   unsigned src = s_val.val();
   unsigned dest = d_val.val();
   unsigned od = od_val.val();
   unsigned inf = inf_val.val();
   unsigned vc = vc_val.val();
   unsigned flit_type = ft_val.val();
   unsigned data = data_val.val();
   fprintf(stderr, "buf recv from %u to %u in %u of (%u, %u ) tp=%d with id= %d at cycle %llu.\n", src, od, dest, inf, vc, flit_type, data,sim->get_cycle_count()); 

#endif
}

void print_arb_recv(_simulator *sim, const _UINT_T(8)& s_val, const _UINT_T(8)& od_val, const _UINT_T(8)& d_val, const _UINT_T(64)& t_val,const _UINT_T(8)& inf_val, const _UINT_T(8)& vc_val, const _UINT_T(8)& ft_val,const _UINT_T(DATA_WIDTH)& data_val ){


#ifdef STAT2 
   unsigned src = s_val.val();
   unsigned dest = d_val.val();
   unsigned od = od_val.val();
   unsigned inf = inf_val.val();
   unsigned vc = vc_val.val();
   unsigned flit_type = ft_val.val();
   unsigned data = data_val.val();
   fprintf(stderr, "arbitrated from %u to %u in %u of (%u, %u ) tp=%d with id= %d at cycle %llu.\n", src, od, dest, inf, vc, flit_type, data,sim->get_cycle_count()); 

#endif
}


void print_recv(_simulator *sim, const _UINT_T(8)& s_val, const _UINT_T(8)& d_val, const _UINT_T(64)& t_val, const _UINT_T(8)& vc_val, const _UINT_T(8)& ft_val,const _UINT_T(DATA_WIDTH)& data_val ){
#ifdef STAT 
   unsigned src = s_val.val();
   unsigned dest = d_val.val();
   unsigned vc = vc_val.val();
   unsigned flit_type = ft_val.val();
   unsigned data = data_val.val();
   //fprintf(stderr, "recv from %u to %u of vc %u with type %d with id= %d at cycle %llu.\n", src, dest, vc, flit_type, data,sim->get_cycle_count()); 
   // calculate the latency and store it
   assert(((src >= 0) || (src< NETWORK_SIZE)));
   assert(((dest >= 0) || (dest< NETWORK_SIZE)));
   assert(((vc>= 0) || (vc< VC_SIZE)));
   switch(flit_type){
   case HEAD:
   packet_counter[src][dest][vc] = 1;
   previous_origin_time[src][dest][vc] = t_val.val();
   if (VC_SIZE == 1){
    // worm hole routing
   unsigned t_latency =  sim->get_cycle_count() - t_val.val();
   glb_latency_count[src][dest] = (double)((double)(glb_latency_count[src][dest]*glb_packet_count[src][dest]+t_latency)/((double)(glb_packet_count[src][dest]+1)));
   glb_packet_count[src][dest] ++;
   glb_total_packet_count++;
        
  }
   break;
   case TAIL:
   {
   
   if (packet_counter[src][dest][vc] != (PACKET_SIZE -1)){
        fprintf(stderr,"wrong: not complete %d, %d, %d, %d\n", src, dest, vc, packet_counter[src][dest][vc]);
   } 
   //assert(packet_counter[src][dest][vc] == (PACKET_SIZE -1));

   unsigned t_latency =  sim->get_cycle_count() - previous_origin_time[src][dest][vc];
   glb_latency_count[src][dest] = (double)((double)(glb_latency_count[src][dest]*glb_packet_count[src][dest]+t_latency)/((double)(glb_packet_count[src][dest]+1)));
   glb_packet_count[src][dest] ++;
   glb_total_packet_count++;
   break;
   }
   case BODY: 
   packet_counter[src][dest][vc] ++;
   break;
}    
   if ((glb_total_packet_count >0) &&(glb_total_packet_count % 50 == 0)){
   //print_stat();
  }
   if ((glb_total_packet_count  >= TOTAL_COUNT) && 
   (glb_total_packet_count % TOTAL_COUNT ==0)){
   print_stat();
   count = 1; 
   }
#endif
}

void print_recv_bus(_simulator *sim, const _UINT_T(8)& s_val, const _UINT_T(8)& d_val, const _UINT_T(64)& t_val, const _UINT_T(8)& p_val ){
#ifdef STAT 
   double total_latency = 0.0;
   unsigned src = s_val.val();
   unsigned dest = d_val.val();
   unsigned type = p_val.val();
   assert((type >=0) && (type < BUS_TYPE_LIMIT));
   //fprintf(stderr, "recv from %u to %u at cycle %llu.\n", src, dest, sim->get_cycle_count()); 
   unsigned t_latency =  sim->get_cycle_count() - t_val.val();   
   glb_bus_latency_count[src][dest][type] = (double)((double)(glb_bus_latency_count[src][dest][type]*glb_bus_packet_count[src][dest][type]+t_latency)/((double)(glb_bus_packet_count[src][dest][type]+1)));
   glb_bus_packet_count[src][dest][type] ++;
   glb_total_packet_count++;
   
   if (glb_total_packet_count >= TOTAL_COUNT &&
   glb_total_packet_count % TOTAL_COUNT ==0 ){
    for (int i=0;i<NETWORK_SIZE;i++){
      for (int j=0;j<NETWORK_SIZE;j++){
         for (int k=0;k<BUS_TYPE_LIMIT;k++){
         total_latency += glb_bus_packet_count[i][j][k]*glb_bus_latency_count[i][j][k];
      }
     }
    }
    fprintf(stderr, "Printing all the latencies for each node:\n");
    fprintf(stderr, ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");
     for (int i=0;i<NETWORK_SIZE;i++){
      for (int j=0;j<NETWORK_SIZE;j++){
       if (i != j){
       for (int k=0;k<BUS_TYPE_LIMIT;k++){
        fprintf(stderr, "src = %u, dest = %u, for type = %d, count = %u",i, j,k, glb_bus_packet_count[i][j][k]);   
       
       fprintf(stderr, " latency = %f\n", glb_bus_latency_count[i][j][k]);      
        }          
       }
     } 
    }
    fprintf(stderr, "Total number of packets = %u, latency = %f\n", glb_total_packet_count, (total_latency/glb_total_packet_count));
    unsigned z = sim->get_cycle_count();
    float rate_w = ((float)bus_utilize_counter_w / (float)z);
    float rate_r = ((float)bus_utilize_counter_r / (float)z);
    float rate_a = ((float)bus_utilize_counter_a / (float)z);
    fprintf(stderr, "ADDR Bus utilization rate is %f, %d out of %d cycles \n", rate_a, bus_utilize_counter_a, z);
    fprintf(stderr, "WRITE Bus utilization rate is %f, %d out of %d cycles \n", rate_w, bus_utilize_counter_w, z);
    fprintf(stderr, "READ Bus utilization rate is %f, %d out of %d cycles \n", rate_r, bus_utilize_counter_r, z);
    fprintf(stderr, "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n");
    fprintf(stderr, "End printing all the latencies for each node:\n");            for (int i=0;i<NETWORK_SIZE;i++){
     for (int j=0;j<NETWORK_SIZE;j++){    
      for (int k=0;k<BUS_TYPE_LIMIT;k++){ 
        glb_bus_latency_count[i][j][k] = 0;
        glb_bus_packet_count[i][j][k] = 0;
      }        
     }
    }
    glb_total_packet_count = 0;
   }

#endif
}



void get_next_src_tlb(_simulator *sim, _UINT_T(8)& a_val, _UINT_T(8)& i_val, _UINT_T(8)& ni_val, const _UINT_T(8)& curr_src, const _UINT_T(8)& curr_dest)
{

 	unsigned src_v = curr_src.val();
        unsigned dest_v = curr_dest.val(); 
        a_val = glb_next_addr[src_v][dest_v];
        i_val = glb_next_interface[src_v][dest_v];
        ni_val = glb_next_other_interface[src_v][dest_v];
#ifdef STAT 
    //fprintf(stderr, "calc route func: s=%d, d=%d, ns=%d, ni=%d, nni=%d \n", src_v, dest_v, a_val.val(), i_val.val(), ni_val.val()); 
#endif
        return;  
}

void get_previous_src_tlb(_simulator *sim, const _UINT_T(8)& src_val, const _UINT_T(8)& if_val, _UINT_T(8)& p_src_val, _UINT_T(8)& p_if_val)
{
  
 	unsigned src_v = src_val.val();
        unsigned curr_if = if_val.val(); 
        p_src_val = glb_previous_addr[src_v][curr_if];
        p_if_val = glb_previous_interface[src_v][curr_if];

}

