/***********************************************************************
  can return either a random 32-bit integer or a random float in [0 1)
  period = 2^800
***********************************************************************/

#define N 25
#define M 7

unsigned int myrand();        /* returns a random integer */
void myrand_init( unsigned int );     /* initialize the generator */


/* return a random float >= 0 and < 1 */
#define rand_float          ((double)myrand() / 4294967296.0)


static unsigned int x[N];         /* the 25 seeds */

void myrand_init( unsigned int seed )
   {
   int k;

   x[0] = (seed|1) & 0xffffffff;
   for (k=1; k<N; k++)
      x[k] = (69069 * x[k-1]) & 0xffffffff;
   }


unsigned int myrand()
   {
   unsigned int y;
   static unsigned int mag01[2]={ 0x0, 0x8ebfd028};  /* "magic" vector */
   static int k = 0;
   int kk;

   if (k==N)
      {
      for (kk=0; kk < N-M; kk++)
         x[kk] = x[kk+M] ^ (x[kk] >> 1) ^ mag01[x[kk] & 1];

      for (; kk < N; kk++)
         x[kk] = x[kk+(M-N)] ^ (x[kk] >> 1) ^ mag01[x[kk] & 1];

      k=0;
      }
   y = x[k++];
   y ^= (y << 7) & 0x2b5b2500;
   y ^= (y << 15) & 0xdb8b0000;
   y &= 0xffffffff;     /* you may delete this line if word size = 32 */
   y ^= (y >> 16);
   return y;
   }





