

#include "armsim.hpp"
#include "ns_parm.hpp"
#include "arm_if_dev.h"



simulator::arm_simulator *new_arm_simulator(bool verbose)
{
	simulator::arm_simulator *pe_sim;

#ifdef __NS_ARM_SIM
    pe_sim = new simulator::arm_simulator(verbose);
    pe_sim->load_fpe(NULL);
   pe_sim->load_program(PROG_NAME, PROG_ARGC, PROG_ARGV, PROG_ENV);
#endif
	return pe_sim;
}

void delete_arm_simulator(simulator::arm_simulator *sim)
{

#ifdef __NS_ARM_SIM
	delete sim;

#endif
}

void init_arm_simulator(simulator::arm_simulator *sim)
{

#ifdef __NS_ARM_SIM
	sim->initialize();;

#endif
}

void run_arm_simulator(simulator::arm_simulator *sim)
{

#ifdef __NS_ARM_SIM
	if (sim->is_running())
	sim->clock_tick();;

#endif
}


void unregister_device(simulator::arm_simulator *pe_sim, unsigned address)
{

#ifdef __NS_ARM_SIM
   pe_sim->dev_master->unregister_device(address);

#endif
}

void register_if_device(simulator::arm_simulator *pe_sim, unsigned address,
	emulator::arm_if_device *pe_if_dev)
{

#ifdef __NS_ARM_SIM
   pe_sim->dev_master->register_device(address, pe_if_dev);

#endif
}
void register_id_device(simulator::arm_simulator *pe_sim, unsigned address,
	emulator::arm_id_device *pe_id_dev)
{

#ifdef __NS_ARM_SIM
   pe_sim->dev_master->register_device(address, pe_id_dev);

#endif
}
