
#include "mad_ast.hpp"
#include "annotation.hpp"
#include <vector>

using namespace mad;
using namespace mad_ast;

using std::vector;
using std::ostream;

extern bool annot_parse_error;
AnnotParagraph *annot_parse_wrapper(const char *annot, const Location *loc);

annot_owner::~annot_owner()
{
	delete_object_list(annots);
	delete_object_list(parsed_annots);
}

void annot_owner::append_annotation(Annotation *aa)
{
	if (aa==NULL) return;

	if (annots==NULL)
		annots = new vector<Annotation *>;

	annots->push_back(aa);
}

bool annot_owner::check_annotations()
{
	if (annots==NULL) return true;

	bool ret = true;
	if (!parsed) {

		parsed_annots = new vector<AnnotParagraph *>;
		vector<Annotation *>::const_iterator ann_it;
		for (ann_it=annots->begin(); ann_it!=annots->end(); ann_it++) {

			parsed_annots->push_back
				(annot_parse_wrapper((*ann_it)->get_content(),
					(*ann_it)->get_loc()));

			if (annot_parse_error)
				ret = false;
		}
		parsed = true;
	}
	return ret;
}

