
#ifndef __EMIT_C_HPP__
#define __EMIT_C_HPP__

#define MACH_CLASS(_symbol) wrapped_symbol("_MACH_CLASS", _symbol)
#define OPER_CLASS(_symbol) wrapped_symbol("_OPER_CLASS", _symbol)
#define MANG_CLASS(_symbol) wrapped_symbol("_MANG_CLASS", _symbol)

#define DEF_NAME(_symbol)  (symbol_get_string(_symbol))
#define BUF_NAME(_symbol)  ("B_" + symbol_get_string(_symbol))
#define MVR_NAME(_symbol)  ("G_" + symbol_get_string(_symbol))
#define VAR_NAME(_symbol)  ("V_" + symbol_get_string(_symbol))
#define ARG_NAME(_symbol)  ("A_" + symbol_get_string(_symbol))
#define FUN_NAME(_symbol)  ("F_" + symbol_get_string(_symbol))

#define BUF_REF(_symbol) wrapped_string("_BUF", BUF_NAME(_symbol))
#define MVR_REF(_symbol) wrapped_string("_MVR", MVR_NAME(_symbol))
#define DEF_REF(_symbol) DEF_NAME(_symbol)
#define ARG_REF(_symbol) ARG_NAME(_symbol)
#define VAR_REF(_prefix, _symbol) (std::string("V_")\
				+_prefix+symbol_get_string(_symbol))
#define MANG_REF(_symbol)  symbol_get_string(_symbol)

#define DIRTY_E_FUN_DEC	"_DIRTY_E_FUN_DEC"
#define DIRTY_FUN_DEC	"_DIRTY_FUN_DEC"
#define E_FUN_DEC		"_E_FUN_DEC"
#define FUN_DEC			"_FUN_DEC"

#define DIRTY_E_FUN_REF	"_DIRTY_E_FUN_REF"
#define DIRTY_FUN_REF	"_DIRTY_FUN_REF"
#define E_FUN_REF		"_E_FUN_REF"
#define FUN_REF			"_FUN_REF"

#define GET_VALUE "_VAL"


#define DTABLE_NAME(_symbol) (VAR_NAME(_symbol) + "__dtable")
#define CODING_NAME(_symbol) (VAR_NAME(_symbol) + "__coding")

#define DTABLE_REF(_symbol) DTABLE_NAME(_symbol)
#define CODING_REF(_symbol) CODING_NAME(_symbol)

#define LOCAL_TEMP 		"L_temp"
#define LOCAL_RESULT	"L_result"
#define LOCAL_IDENT(_symbol)  ("L_" + symbol_get_string(_symbol)) 


#define DECODER_TABLE(_symbol) (symbol_get_string(_symbol)+"_table")
#define DECODER_NAME(_symbol)  ("DEC_" + symbol_get_string(_symbol))

#define DECODER_PAT_FILE(_symbol) (symbol_get_string(_symbol)+"_pat.def")
#define DECODER_DEC_FILE(_symbol) (symbol_get_string(_symbol)+"_pat.cpp")
#define DECODER_HDR_FILE(_symbol) (symbol_get_string(_symbol)+"_dec.hpp")
#define DECODER_TAB_FILE(_symbol) (symbol_get_string(_symbol)+"_tab.cpp")
#define DECODER_MAIN_FILE(_symbol) (symbol_get_string(_symbol)+"_dec.cpp")
#define DECODER_COMMON_HDR "auto_decoder.hpp"

#define OPER_ID_TYPE "_OPER_ID_T"
#define MACH_ID_TYPE "_MACH_ID_T"

#define OSM_LIB_INCLUDE "interface.hpp"

#define DEFN_DEC_FILE  "define.hpp"
#define MACH_DEC_FILE  "machines.hpp"
#define OPER_DEC_FILE  "opers.hpp"

#define DEFN_IMP_FILE  "define.cpp"
#define MACH_IMP_FILE  "machines.cpp"
#define FUNC_IMP_FILE  "func.cpp"
#define OPER_IMP_FILE  "opers.cpp"
#define OPER_LIST_FILE "oper_list.hpp"
#define MACH_LIST_FILE "mach_list.hpp"
#define MANG_LIST_FILE "mang_list.hpp"

#endif
