

#include "define.hpp"
#include "func.cpp"
#include <iostream>

int main()
{
	std::cerr << nn[0].hex() << std::endl;
	std::cerr << nn[1].hex() << std::endl;
	std::cerr << n64.hex() << std::endl;

	_UINT_T(120) a("0x0123456789abcdefedcba98765432");
	_INT_T(120) b("0xCC23456789abcdefedcba987654321");

	F_deposit2long(a,b,0xc5c6c7c8c9ll,0xa1a2a3a4a5ll);

	std::cerr << a.hex() << std::endl;
	std::cerr << "0x1235fffffffffffc5c6c7c8c9432" << std::endl;
	std::cerr << b.hex() << std::endl;
	std::cerr << "0xcc23456789abcdefedcb1a2a3a4a51" << std::endl;

	_UINT_T(64) a1(0x123456789abcdef0ll);
	_INT_T(64)  b1(0x1234567890abcdefll);
	F_deposit2short(a1,b1,"0xc1c2c3c4c5c6c7c8c9cacbcccdcecfc0",
							"0xa0a1a2a3a4a5a6a7a8a9aaabacadaeaf");

	std::cerr << a1.hex() << std::endl;
	std::cerr << "0x123456c1c2c3cef0" << std::endl;
	std::cerr << b1.hex() << std::endl;
	std::cerr << "0x1234567890adaeaf" << std::endl;

	_INT_T(128) a2("0xFFFFFFFFFFFFFFFFCFFFFFFFFFFFFFFF");
	_INT_T(64)  b2;
	_UINT_T(64) c2;
	F_test_castll(b2, a2);
	F_test_castull(c2, a2);
	std::cerr << b2.hex() << std::endl;
	std::cerr << c2.hex() << std::endl;
	std::cerr << a2.hex() << std::endl;
	std::cerr << (-a2).hex() << std::endl;

	_UINT_T(128) a3;
	_FLT_T b3;
	F_test_castf(a3, b3, 100.0);
	std::cerr << a3.hex() << std::endl;
	std::cerr << b3.sci() << std::endl;

	_UINT_T(128) a4;
	_DBL_T b4;
	F_test_castd(a4, b4, 100000.0);
	std::cerr << a4.hex() << std::endl;
	std::cerr << b4.sci() << std::endl;

	_INT_T(32) a5;
	_UINT_T(32) b5;
	F_test_divi(a5, -1023, 24);
	F_test_divu(b5, -1023, 24);
	std::cerr << a5.dec() << std::endl;
	std::cerr << b5.dec() << std::endl;

	F_test_divi(a5, 1023, -24);
	F_test_divu(b5, 1023, -24);
	std::cerr << a5.dec() << std::endl;
	std::cerr << b5.dec() << std::endl;

	F_test_modi(a5, -1023, 24);
	std::cerr << a5.dec() << std::endl;
	F_test_modi(a5, -1023, -24);
	std::cerr << a5.dec() << std::endl;
	F_test_modi(a5, 1023, 24);
	std::cerr << a5.dec() << std::endl;
	F_test_modi(a5, 1023, -24);
	std::cerr << a5.dec() << std::endl;

	F_test_subi(a5, -1023, 24);
	std::cerr << a5.dec() << std::endl;
	F_test_subi(a5, -1023, -24);
	std::cerr << a5.dec() << std::endl;
	F_test_subi(a5, 1023, 24);
	std::cerr << a5.dec() << std::endl;
	F_test_subi(a5, 1023, -24);
	std::cerr << a5.dec() << std::endl;

	F_test_muli(a5, -1023, 24);
	std::cerr << a5.dec() << std::endl;
	F_test_muli(a5, -1023, -24);
	std::cerr << a5.dec() << std::endl;
	F_test_muli(a5, 1023, 24);
	std::cerr << a5.dec() << std::endl;
	F_test_muli(a5, 1023, -24);
	std::cerr << a5.dec() << std::endl;

	F_test_cmpi(a5, 0xc);
	std::cerr << a5.hex() << std::endl;
	F_test_cmpi(a5, -0xc);
	std::cerr << a5.hex() << std::endl;

	F_test_cmpu(b5, 0xc);
	std::cerr << b5.hex() << std::endl;
	F_test_cmpu(b5, -0xc);
	std::cerr << b5.hex() << std::endl;

	_INT_T(64) a6;
	F_test_casti1(a6, -0xc);
	std::cerr << a6.hex() << std::endl;
	F_test_casti2(a6, -0xc);
	std::cerr << a6.hex() << std::endl;
	F_test_casti3(a2, -0xc);
	std::cerr << a2.hex() << std::endl;
	F_test_casti4(a2, -0xc);
	std::cerr << a2.hex() << std::endl;

	_UINT_T(32) a7;
	_UINT_T(128) a8;
	F_test_castu1(a7, -0xc);
	std::cerr << a7.hex() << std::endl;
	F_test_castu2(a7, -0xc);
	std::cerr << a7.hex() << std::endl;
	F_test_castu3(a8, -0xc);
	std::cerr << a8.hex() << std::endl;
	F_test_castu4(a8, -0xc);
	std::cerr << a8.hex() << std::endl;
	std::cerr << (-a8).hex() << std::endl;

}
