
#ifndef __MORE_MANAGERS_HPP__
#define __MORE_MANAGERS_HPP__

/* include libosm stuff */
#include "include_osm.hpp"
#include <iostream>

/** short hand */

/** simple resource manager. */
typedef unit_manager<_FLT_T> mclass1;
typedef unit_manager<_STR_T> mclass2;
typedef unit_manager<_TUPLE_T(_UINT_T(3),_FLT_T)> mclass3;

/** The dummy manager. */
template <class I, class V>
class dummy_resource {

	public:
		/** token type. */
		typedef class _token_<dummy_resource<I,V> > TOKEN_T;

		/** Constructor. */
		dummy_resource(const std::string& name) : name(name) {
			token = new TOKEN_T(this);
		}

		/** Destructor. */
		~dummy_resource() {
			delete token;
		}

		bool token_free_for_alloc(const I& ind, _base_machine_ *obj) {
			return true;
		}

		bool token_free_for_inquire(const I& ind, _base_machine_ *obj) {
			return true;
		}

		bool token_good_to_reclaim(TOKEN_T *token, _base_machine_ *obj) {
			return true;
		}

		TOKEN_T *allocate_token(const I& ind,_base_machine_ *obj) {
			return token;
		}

		TOKEN_T *allocate_token_temp(const I& ind,_base_machine_ *obj) {
			return token;
		}

		void reclaim_token(TOKEN_T *token, _base_machine_ *obj) {
		}

		void discard_token(TOKEN_T *token, _base_machine_ *obj) {
		}

		V read_token(const I& ind, _base_machine_ *obj) {
			return V();
		}

		V read_token(_base_machine_ *obj, TOKEN_T *token) {
			return V();
		}

		void reset() {
		}

	private:
		std::string name;
		TOKEN_T *token;
};

typedef dummy_resource<_UINT_T(3), int> mclass10;
typedef dummy_resource<_STR_T, int> mclass12;
typedef dummy_resource<_FLT_T, int> mclass11;


#endif
